//		----------------------------------------------------------
//		-- fredrik olofsson 040331								--
//		-- ported to pd 060511									--
//		-- distributed under GNU GPL license					--
//		----------------------------------------------------------

#include "m_pd.h"
#include <math.h>

static t_class *this_class;

typedef struct _f0_slub {
	t_object x_ob;
	t_float x_valRight;
} x_f0_slub;

void f0_slub_func(x_f0_slub *f0_slub);

//----------------------------------------------------------------------------------------------
void *f0_slub_new(t_floatarg value) {
	x_f0_slub *f0_slub= (x_f0_slub *)pd_new(this_class);
	floatinlet_new(&f0_slub->x_ob, &f0_slub->x_valRight);
	if(value==0) {
		f0_slub->x_valRight= 5;
	} else {
		f0_slub->x_valRight= value;
	}
	return (void *)f0_slub;
}

//----------------------------------------------------------------------------------------------
void f0_slub_float(x_f0_slub *f0_slub, t_floatarg value) {
	f0_slub->x_valRight= value;
	f0_slub_func(f0_slub);
}
void f0_slub_bang(x_f0_slub *f0_slub) {
	f0_slub_func(f0_slub);
}

//----------------------------------------------------------------------------------------------
void f0_slub_func(x_f0_slub *f0_slub) {
	t_int
			i
					,
			j
	,
			k
					,
			l
	,
			x
					;
			x
	=
			(t_int)round
					(
			pow
	(
	2
	,
			f0_slub->x_valRight
					)
			)
	;
			for
					(
			i
					=
					0
						;
			i
	<
					x
			;
	i++
			)
					{
			for
	(j=
			0
			;
					j
			<
	x
	;
			j++
					)
			{		for
			(
					k
			=0
			;
						k<
	x
			;
					k++
			)
	{
			for
			
					(
			l
			=
					0;
			l
					<
			x
	;
			l++
					)
			{
	fmod(
			l				,
			3.1415
	)
			;
					}
			}}
	}
}

//----------------------------------------------------------------------------------------------
void f0_slub_setup(void) {
	this_class= class_new(gensym("f0_slub"), (t_newmethod)f0_slub_new, 0, sizeof(x_f0_slub), 0, A_DEFFLOAT, 0);
	class_addbang(this_class, (t_method)f0_slub_bang);
	class_addfloat(this_class, f0_slub_float);
	post("f0_slub v1.0  distributed under GNU GPL license");
}
